(function() {
    var proxySettings = {
        proxyType: "none"
    };
    browser.proxy.settings.set({value: proxySettings});

    function handleInstalled(details) {
        if(details.reason === "install") {
            browser.tabs.create({
                url: "https://converter.qweb.de/installok"
            });
        }
    }

    browser.runtime.onInstalled.addListener(handleInstalled);

    function redirectQwebApiToLocal() {
        return {
            redirectUrl: "https://converter.qweb.de/converter"
        };
    }

    browser.webRequest.onBeforeRequest.addListener(
        redirectQwebApiToLocal,
        {
            urls: [
                    "*://api.qweb.de/converter",
                    "*://api.qweb.de/converter/*"
            ]
        },
        ["blocking"]
    );

    function getQueryParam(url,param) {
        var queryString = url.substring( url.indexOf('?') + 1 );
        var params = {}, queries, temp, i, l;
        // Split into key/value pairs
        queries = queryString.split("&");
        // Convert the array of strings into an object
        for ( i = 0, l = queries.length; i < l; i++ ) {
            temp = queries[i].split('=');
            params[temp[0]] = temp[1];
        }
        if(param.indexOf(param) === -1)
            return false;

        return params[param];
    }

    var varqwebsearchengineredirect = 0;
    function searchEngineRedirect(details) {
        var seRedirectParam = varqwebsearchengineredirect;
        if(seRedirectParam === 0)
            return;

        if(
            !(getQueryParam(details.url,'q')) &&
            !(getQueryParam(details.url,'p'))
        )
            return;

        var searchString;
        searchString = getQueryParam(details.url,'q');
        if(!searchString)
            searchString = getQueryParam(details.url,'p');

        switch(seRedirectParam){
            case 1:
                if(details.url.indexOf("google") === -1){
                    return {
                        redirectUrl: "https://www.google.de/search?q="+searchString
                    };
                }
                break;
            case 2:
                if(details.url.indexOf("bing") === -1){
                    return {
                        redirectUrl: "https://www.bing.com/search?cc=de&q="+searchString
                    };
                }
                break;
            case 3:
                if(details.url.indexOf("yahoo") === -1){
                    return {
                        redirectUrl: "https://de.search.yahoo.com/search?p="+searchString
                    };
                }
                break;
            case 4:
                if(details.url.indexOf("duckduckgo") === -1){
                    return {
                        redirectUrl: "https://www.duckduckgo.com/?q="+searchString
                    };
                }
                break;
            case 5:
                if(details.url.indexOf("ecosia.org") === -1){
                    return {
                        redirectUrl: "https://www.ecosia.org/search?q="+searchString
                    };
                }
                break;
        }
    }

    function settingsRedirectReturned(result) {
        varqwebsearchengineredirect = parseInt(result.qwebsearchengineredirect);

        if(varqwebsearchengineredirect === 0)
            return false;

        browser.webRequest.onBeforeRequest.addListener(
            searchEngineRedirect,
            {
                urls: [
                    "*://*.bing.com/*",
                    "*://bing.com/*",

                    "*://suche.t-online.de/*",
                    "*://suche.web.de/*",
                    "*://suche.gmx.net/*",
                    "*://suche.aol.de/*",

                    "*://sm.de/*",
                    "*://*.sm.de/*",
                    "*://ask.com/*",
                    "*://*.ask.com/*",
                    "*://*.sm.de/*",

                    "*://*.fireball.com/*",
                    "*://fireball.de/*",
                    "*://*.fireball.de/*",
                    "*://fireball.de/*",

                    "*://duckduckgo.com/?q=*",
                    "*://*.duckduckgo.com/?q=*",

                    "*://*.search.yahoo.com/*",

                    "*://*.google.de/*",
                    "*://*.google.ad/*",
                    "*://*.google.ae/*",
                    "*://*.google.am/*",
                    "*://*.google.as/*",
                    "*://*.google.at/*",
                    "*://*.google.az/*",
                    "*://*.google.ba/*",
                    "*://*.google.be/*",
                    "*://*.google.bf/*",
                    "*://*.google.bg/*",
                    "*://*.google.bi/*",
                    "*://*.google.bj/*",
                    "*://*.google.bs/*",
                    "*://*.google.ca/*",
                    "*://*.google.cat/*",
                    "*://*.google.cd/*",
                    "*://*.google.cf/*",
                    "*://*.google.cg/*",
                    "*://*.google.ch/*",
                    "*://*.google.ci/*",
                    "*://*.google.cl/*",
                    "*://*.google.cm/*",
                    "*://*.google.co.bw/*",
                    "*://*.google.co.ck/*",
                    "*://*.google.co.cr/*",
                    "*://*.google.co.id/*",
                    "*://*.google.co.in/*",
                    "*://*.google.co.jp/*",
                    "*://*.google.co.ke/*",
                    "*://*.google.co.kr/*",
                    "*://*.google.co.ls/*",
                    "*://*.google.co.ma/*",
                    "*://*.google.co.nz/*",
                    "*://*.google.co.th/*",
                    "*://*.google.co.tz/*",
                    "*://*.google.co.ug/*",
                    "*://*.google.co.uk/*",
                    "*://*.google.co.uz/*",
                    "*://*.google.co.ve/*",
                    "*://*.google.co.vi/*",
                    "*://*.google.co.za/*",
                    "*://*.google.co.zm/*",
                    "*://*.google.co.zw/*",
                    "*://*.google.com/*",
                    "*://*.google.com.af/*",
                    "*://*.google.com.ag/*",
                    "*://*.google.com.ai/*",
                    "*://*.google.com.ar/*",
                    "*://*.google.com.au/*",
                    "*://*.google.com.bd/*",
                    "*://*.google.com.bh/*",
                    "*://*.google.com.bn/*",
                    "*://*.google.com.bo/*",
                    "*://*.google.com.br/*",
                    "*://*.google.com.by/*",
                    "*://*.google.com.bz/*",
                    "*://*.google.com.co/*",
                    "*://*.google.com.do/*",
                    "*://*.google.com.ec/*",
                    "*://*.google.com.eg/*",
                    "*://*.google.com.et/*",
                    "*://*.google.com.fj/*",
                    "*://*.google.com.gh/*",
                    "*://*.google.com.gi/*",
                    "*://*.google.com.gt/*",
                    "*://*.google.com.hk/*",
                    "*://*.google.com.jm/*",
                    "*://*.google.com.kh/*",
                    "*://*.google.com.kw/*",
                    "*://*.google.com.lb/*",
                    "*://*.google.com.lk/*",
                    "*://*.google.com.ly/*",
                    "*://*.google.com.mt/*",
                    "*://*.google.com.mx/*",
                    "*://*.google.com.my/*",
                    "*://*.google.com.na/*",
                    "*://*.google.com.nf/*",
                    "*://*.google.com.ng/*",
                    "*://*.google.com.ni/*",
                    "*://*.google.com.np/*",
                    "*://*.google.com.om/*",
                    "*://*.google.com.pa/*",
                    "*://*.google.com.pe/*",
                    "*://*.google.com.ph/*",
                    "*://*.google.com.pk/*",
                    "*://*.google.com.pr/*",
                    "*://*.google.com.py/*",
                    "*://*.google.com.qa/*",
                    "*://*.google.com.sa/*",
                    "*://*.google.com.sb/*",
                    "*://*.google.com.sg/*",
                    "*://*.google.com.sl/*",
                    "*://*.google.com.sv/*",
                    "*://*.google.com.tj/*",
                    "*://*.google.com.tr/*",
                    "*://*.google.com.tw/*",
                    "*://*.google.com.ua/*",
                    "*://*.google.com.uy/*",
                    "*://*.google.com.vc/*",
                    "*://*.google.com.vn/*",
                    "*://*.google.cv/*",
                    "*://*.google.cz/*",
                    "*://*.google.dj/*",
                    "*://*.google.dk/*",
                    "*://*.google.dm/*",
                    "*://*.google.dz/*",
                    "*://*.google.ee/*",
                    "*://*.google.es/*",
                    "*://*.google.fi/*",
                    "*://*.google.fm/*",
                    "*://*.google.fr/*",
                    "*://*.google.ga/*",
                    "*://*.google.ge/*",
                    "*://*.google.gl/*",
                    "*://*.google.gm/*",
                    "*://*.google.gp/*",
                    "*://*.google.gr/*",
                    "*://*.google.gy/*",
                    "*://*.google.hn/*",
                    "*://*.google.hr/*",
                    "*://*.google.ht/*",
                    "*://*.google.hu/*",
                    "*://*.google.ie/*",
                    "*://*.google.iq/*",
                    "*://*.google.is/*",
                    "*://*.google.it/*",
                    "*://*.google.it.ao/*",
                    "*://*.google.jo/*",
                    "*://*.google.kg/*",
                    "*://*.google.ki/*",
                    "*://*.google.kz/*",
                    "*://*.google.la/*",
                    "*://*.google.li/*",
                    "*://*.google.lk/*",
                    "*://*.google.lt/*",
                    "*://*.google.lu/*",
                    "*://*.google.lv/*",
                    "*://*.google.md/*",
                    "*://*.google.mg/*",
                    "*://*.google.mk/*",
                    "*://*.google.ml/*",
                    "*://*.google.mn/*",
                    "*://*.google.ms/*",
                    "*://*.google.mu/*",
                    "*://*.google.mv/*",
                    "*://*.google.mw/*",
                    "*://*.google.ne/*",
                    "*://*.google.nl/*",
                    "*://*.google.no/*",
                    "*://*.google.nr/*",
                    "*://*.google.nu/*",
                    "*://*.google.pl/*",
                    "*://*.google.pn/*",
                    "*://*.google.ps/*",
                    "*://*.google.pt/*",
                    "*://*.google.ro/*",
                    "*://*.google.rs/*",
                    "*://*.google.ru/*",
                    "*://*.google.rw/*",
                    "*://*.google.sc/*",
                    "*://*.google.se/*",
                    "*://*.google.sh/*",
                    "*://*.google.si/*",
                    "*://*.google.sk/*",
                    "*://*.google.sm/*",
                    "*://*.google.sn/*",
                    "*://*.google.so/*",
                    "*://*.google.st/*",
                    "*://*.google.td/*",
                    "*://*.google.tg/*",
                    "*://*.google.tk/*",
                    "*://*.google.tl/*",
                    "*://*.google.tm/*",
                    "*://*.google.tn/*",
                    "*://*.google.to/*",
                    "*://*.google.tt/*",
                    "*://*.google.vg/*",
                    "*://*.google.vu/*"
                ]
            },
            ["blocking"]
        );
    }

    function onSettingsRedirectError(error) {
        //console.log('Error:');
        //console.log(error);
    }

    var gettingRedirectSettings = browser.storage.local.get("qwebsearchengineredirect");
    gettingRedirectSettings.then(settingsRedirectReturned, onSettingsRedirectError);

    function reqListener () {
        var settingsObj = JSON.parse(this.responseText);
        var tmpVal = '';
        if(settingsObj){
            console.log(settingsObj);
            if(settingsObj.hasOwnProperty('DisableConverter')){
                tmpVal = settingsObj['DisableConverter'];
                tmpVal = tmpVal.replace('0x','');
            }else{
                tmpVal = 0;
            }
            browser.storage.local.set({'qwebdisableconverter': tmpVal});

            if(settingsObj.hasOwnProperty('DisablePriceFinder')){
                tmpVal = settingsObj['DisablePriceFinder'];
                tmpVal = tmpVal.replace('0x','');
            }else{
                tmpVal = 0;
            }
            browser.storage.local.set({'qwebdisablepricefinder': tmpVal});

            if(settingsObj.hasOwnProperty('DisableSearchImages') !== -1){
                tmpVal = settingsObj['DisableSearchImages'];
                tmpVal = tmpVal.replace('0x','');
            }else{
                tmpVal = 0;
            }
            browser.storage.local.set({'qwebdisablesearchimages': tmpVal});

            if(settingsObj.hasOwnProperty('SearchEngineRedirect')){
                tmpVal = settingsObj['SearchEngineRedirect'];
                tmpVal = tmpVal.replace('0x','');
            }else{
                tmpVal = 0;
            }
            browser.storage.local.set({'qwebsearchengineredirect': tmpVal});
        }
    }

    var oReq = new XMLHttpRequest();
    oReq.addEventListener("load", reqListener);
    oReq.open("GET", "http://localhost:44555/converter/get_settings_api");
    oReq.send();
    /*
    function rewriteUserAgentHeader(e) {
        e.requestHeaders.forEach(function(header){
            if (header.name.toLowerCase() === "host") {
                header.value = 'localhost:44555';
            }
        });
        return {requestHeaders: e.requestHeaders};
    }

    browser.webRequest.onBeforeSendHeaders.addListener(
        rewriteUserAgentHeader,
        {urls: [
            '*://api.qweb.de/converter',
            '*://api.qweb.de/converter/*'
        ]},
        ["blocking", "requestHeaders"]
    );
    */
})();